; @com.wudsn.ide.asm.mainsourcefile=agd.asm
;******************************************************************
setup_bitmap_dlist  lda #BLANK8         ;first byte of dlists
                    sta DLISTSTART1
                    sta DLISTSTART2

                    lda #>DLISTSTART1   ;first LMS address into AD1 and AD2
                    sta AD1+1
                    lda #>DLISTSTART2
                    sta AD2+1
                    lda #1
                    sta AD1
                    sta AD2
                    
                    lda #0  ;first buffer address
                    sta AD3
                    lda #>BITMAPSCREEN
                    sta AD3+1
                    
                    ldx #SCREEN_HEIGHT

@                   ldy #0
                    lda #LMS+MODEF
                    sta (AD1),y         ;set LMS byte
                    sta (AD2),y
                    iny
                    lda #0              ;set lo byte of screen address
                    sta (AD1),y
                    lda #SCREEN_WIDTH
                    sta (AD2),y
                    iny
                    
                    lda AD3+1           ;set hi byte of screen address
                    sta (AD1),y
                    sta (AD2),y
                    iny
                    
                    lda #LMS+MODEF
                    sta (AD1),y         ;set LMS byte
                    sta (AD2),y
                    iny
                    lda #0              ;set lo byte of screen address
                    sta (AD1),y
                    lda #SCREEN_WIDTH
                    sta (AD2),y
                    iny
                    
                    lda AD3+1           ;set hi byte of screen address
                    sta (AD1),y
                    sta (AD2),y
                    
                    lda ad1             ;advance two lms steps in dlists (6 bytes)
                    clc
                    adc #6
                    sta ad1
                    bcc @+
                    inc ad1+1
                    clc
@                   lda ad2
                    adc #6
                    sta ad2
                    bcc @+
                    inc ad2+1
@                                       

                    inc ad3+1           ;next line screen address
                    
                    dex                 ;check counter
                    bne @-2
                    
                    lda #DLISTENDJUMP   ;set dlist end jump to start of dlist
                    ldy #0
                    sta (ad1),y
                    sta (ad2),y
                    iny
                    lda #<DLISTSTART1
                    sta (ad1),y
                    lda #<DLISTSTART1
                    sta (ad1),y
                    iny
                    lda #>DLISTSTART1
                    sta (ad1),y
                    lda #>DLISTSTART2
                    sta (ad2),y
                    
                    lda #<DLISTSTART1   ;set dlist to first buffer
                    sta DLISTL
                    lda #>DLISTSTART1
                    sta DLISTHI
                    sta DLISTH
                    rts
                    
;******************************************************************

;.align
;BITMAP_DLIST1   DTA BLANK8
;
;.REPT SCREEN_HEIGHT
;                DTA LMS+MODEF,a(BITMAPSCREEN+#*256)
;                DTA LMS+MODEF,a(BITMAPSCREEN+#*256)
;.ENDR
;                DTA DLISTENDJUMP,a(BITMAP_DLIST)

;BITMAP_DLIST2   DTA BLANK8
;
;.REPT SCREEN_HEIGHT
;                DTA LMS+MODEF,a(BITMAPSCREEN+SCREEN_WIDTH+#*256)
;                DTA LMS+MODEF,a(BITMAPSCREEN+SCREEN_WIDTH+#*256)
;.ENDR
;                DTA DLISTENDJUMP,a(BITMAP_DLIST2)
