; @com.wudsn.ide.asm.mainsourcefile=agd.asm
;******************************************************************

nmi_handler             bit NMIST
                        bpl nmi_not_dli
                        bmi dli_handler
nmi_not_vbi             lda #%00100000
                        bit NMIST
                        bne nmi_not_reset
                        sta nmires
                        rti
nmi_not_reset           pla
                        rti
nmi_not_dli             pha
                        bvc nmi_not_vbi
                        txa
                        pha
                        tya
                        pha
                        sta NMIRES
vbi_handler_jmp         jmp vbi_handler0

vbi_handler0            pla
                        tay
                        pla
                        tax
                        pla
                        rti

dli_handler             ;pha
                        ;txa
                        ;pha
                        ;tya
                        ;pha

                        sta ACC       ;3
                        stx REGX
                        sty REGY
                
                        lda ACC       ;3
                        ldx REGX
                        ldy REGY
                        rti           ;6


switch_vbi_bitmap_mode  lda <vbi_handler_bitmap_mode
                        sta vbi_handler_jmp+1
                        lda >vbi_handler_bitmap_mode
                        sta vbi_handler_jmp+2
                        rts

vbi_handler_bitmap_mode lda #%00000000
                        sta NMIEN

                        lda #1
                        sta frame_start
                        
                        lda render_done
                        beq @+              ;skip if no need to flip buffers

                        lda #0              ;rendering done, flip buffers
                        sta render_done
                        jsr flip_buffers
@
                        
                        lda #%11000000
                        sta NMIEN

                        pla
                        tay
                        pla
                        tax
                        pla
                        rti
